#ifndef ASDF_CONFIG_HPP
#define ASDF_CONFIG_HPP

#include <string>

namespace ASDF {

// Software version

#define ASDF_VERSION_MAJOR 7
#define ASDF_VERSION_MINOR 3
#define ASDF_VERSION_PATCH 1

#define ASDF_VERSION "7.3.1"

int versionMajor();
int versionMinor();
int versionPatch();

std::string Version();

void checkVersion(const char *header_version);

#define ASDF_CHECK_VERSION (::ASDF::checkVersion(ASDF_VERSION))

// blosc support

#if 1
#define ASDF_HAVE_BLOSC 1
#else
#undef ASDF_HAVE_BLOSC
#endif

// blosc2 support

#if 1
#define ASDF_HAVE_BLOSC2 1
#else
#undef ASDF_HAVE_BLOSC2
#endif

// bzip2 support

#if 1
#define ASDF_HAVE_BZIP2 1
#else
#undef ASDF_HAVE_BZIP2
#endif

// OpenSSL support

#if 1
#define ASDF_HAVE_OPENSSL 1
#else
#undef ASDF_HAVE_OPENSSL
#endif

// zlib support

#if 1
#define ASDF_HAVE_ZLIB 1
#else
#undef ASDF_HAVE_ZLIB
#endif

// libzstd support

#if 1
#define ASDF_HAVE_LIBZSTD 1
#else
#undef ASDF_HAVE_LIBZSTD
#endif

} // namespace ASDF

#define ASDF_CONFIG_HPP_DONE
#endif // #ifndef ASDF_CONFIG_HPP
#ifndef ASDF_CONFIG_HPP_DONE
#error "Cyclic include depencency"
#endif
